Bug 218602 - CVE-2006-6106 Multiple problems in net/bluetooth/cmtp/capi.c
Summary: CVE-2006-6106 Multiple problems in net/bluetooth/cmtp/capi.c
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel
Version: 4.0
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
: ---
Assignee: Marcel Holtmann
QA Contact: Brian Brock
URL:
Whiteboard: impact=moderate,source=redhat,reporte...
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2006-12-06 13:18 UTC by Marcel Holtmann
Modified: 2007-11-30 22:07 UTC (History)
3 users (show)

Fixed In Version: RHSA-2007-0014
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2007-01-30 14:44:43 UTC


Attachments (Terms of Use)
Proposed patch from Marcel Holtmann (3.63 KB, patch)
2006-12-11 14:19 UTC, Marcel Holtmann
no flags Details | Diff


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2007:0014 normal SHIPPED_LIVE Important: kernel security update 2007-01-30 14:25:00 UTC

Description Marcel Holtmann 2006-12-06 13:18:08 UTC
From Al Viro:

Handling of incoming packet in net/bluetooth/cmtp/capi.c:

        case CAPI_FUNCTION_GET_SERIAL_NUMBER:
                controller = CAPIMSG_U32(skb->data, CAPI_MSG_BASELEN + 12);
                if (!info && ctrl) {
                        memset(ctrl->serial, 0, CAPI_SERIAL_LEN);
                        strncpy(ctrl->serial,
                                skb->data + CAPI_MSG_BASELEN + 17,
                                skb->data[CAPI_MSG_BASELEN + 16]);
                }
                break;

The "->serial" is "unsigned char[8]" and no checks are done on
"skb->data[CAPI_MSG_BASELEN + 16]" incoming packet.

This could mess with "struct capi_ctr" from include/linux/isdn/capilli.h and
give a posibility to overwrite "struct proc_dir_entry *procent;".

The "case CAPI_FUNCTION_GET_MANUFACTURER:" in the same place is dealing with
same problem.

Comment 4 Jason Baron 2006-12-18 21:55:46 UTC
committed in stream E5 build 42.0.4

Comment 6 Jason Baron 2006-12-20 19:01:23 UTC
committed in stream U5 build 42.33. A test kernel with this patch is available
from http://people.redhat.com/~jbaron/rhel4/


Comment 7 Mike Gahagan 2007-01-24 20:55:35 UTC
verified that the patch is in the 42.0.8 kernel.


Comment 9 Red Hat Bugzilla 2007-01-30 14:44:43 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2007-0014.html



Note You need to log in before you can comment on or make changes to this bug.